class IsbnValidator < ActiveModel::EachValidator

  def validate_each(record, attribute, value)
    unless valid?(value.to_s)
      record.errors[attribute] << (options[:message] || I18n.t('flash_validators.errors.messages.isbn'))
    end
  end

  private

  def valid_format?(value)
    value = '' if value.nil?
    value.gsub!(/-| /, '')
    value.downcase!

    [10, 13].include?(value.size) &&
    value.chars.all? { |char| ['0','1','2','3','4','5','6','7','8','9','0','x'].include?(char) }
  end

  def valid?(value)
    valid_format?(value)
  end

end