class PasswordValidator < ActiveModel::EachValidator

  def validate_each(record, attribute, value)
    unless valid?(value, options)
      record.errors[attribute] << (options[:message] || I18n.t('flash_validators.errors.messages.password'))
    end
  end

  private

  def valid_format?(value, options)
    if options[:strict]
      value =~ /^(?=^.{1,255}$)((?=.*[A-Za-z0-9])(?=.*[A-Z])(?=.*[a-z]))^.*$/
    else
      value =~ /^[a-z0-9!@#$%^&*_-]{1,255}$/
    end
  end

  def valid?(value, options)
    valid_format?(value, options)
  end

end